#define DEFINITION_Dyadic_Base

#define Dyadic_Base_MAXSIZE	100000

#define BOOLEAN unsigned char

#ifdef __alpha

#define Dyadic_Base_MinInt	-(((long) 1)<<61)
#define Dyadic_Base_BITZAHL	31
#define LONGVALUE unsigned long
#define BASIS	2147483648UL
#define MAXNAT	2147483647UL


#elif i386

#define Dyadic_Base_MinInt	-(1<<29)
#define Dyadic_Base_BITZAHL	31
#define LONGVALUE long long
#define BASIS	2147483648UL
#define MAXNAT	2147483647UL


#else

#define Dyadic_Base_MinInt	-(1<<29)
#define Dyadic_Base_BITZAHL	16
#define LONGVALUE unsigned long
#define BASIS		65536UL
#define MAXNAT	65535UL

#endif

typedef  unsigned int Dyadic_Base_WertFeld[Dyadic_Base_MAXSIZE];

extern void Dyadic_Base_SysAdd (Dyadic_Base_WertFeld A, Dyadic_Base_WertFeld B, Dyadic_Base_WertFeld C, long ANZAHL);
extern void Dyadic_Base_SysSub (Dyadic_Base_WertFeld A, Dyadic_Base_WertFeld B, Dyadic_Base_WertFeld C, long ANZAHL, BOOLEAN *NEGATIV);
extern void Dyadic_Base_SysBlockShl (Dyadic_Base_WertFeld A, long ANZAHL, long COUNT);
extern void Dyadic_Base_SysMul (Dyadic_Base_WertFeld A, Dyadic_Base_WertFeld B, Dyadic_Base_WertFeld C, long Aanzahl, long Banzahl, long Canzahl);
extern void Dyadic_Base_SysDiv (Dyadic_Base_WertFeld A, Dyadic_Base_WertFeld B, Dyadic_Base_WertFeld C, long Aanzahl, long Banzahl, long Canzahl, BOOLEAN MODUL);
